#!/eci/bin/perl
#
# Print a report for each department showing broken out totals
# for each user in a department, sorted by login.  Printing is 
# via enscript (it used to be troff and tbl, but the tbls got
# too big.
#
#

$NUMDATE = "/usr/engineering1/home/acct/bin/numdate";
$CHARGE_FILE = "/usr/engineering1/home/acct/tmp/charge_file";
$TEMP = "/tmp/dept.user.report.$$";
$DATE = `date`;
chop ($DATE);

$m{'01'} = "Jan";
$m{'02'} = "Feb";
$m{'03'} = "Mar";
$m{'04'} = "Apr";
$m{'05'} = "May";
$m{'06'} = "Jun";
$m{'07'} = "Jul";
$m{'08'} = "Aug";
$m{'09'} = "Sep";
$m{'10'} = "Oct";
$m{'11'} = "Nov";
$m{'12'} = "Dec";

# Today's date in numeric form.  Good for comparisions.
$numdate = `$NUMDATE`;

# The date two months from now.
$twomon = $numdate + 202;

# The date one month from now.
$onemon = $numdate + 102;

# $5 minimun charge.
$MIN = 5;

# Rates for Non-UC users are 60% above UC users.
$NONUC_MULT = 1.60;

system("sort -t\\| +2 -3 +0 -1 +4 -5 $CHARGE_FILE > $TEMP");
open(charge_file, $TEMP) || die "Can't open $TEMP.";

# Prime the variables with the first line of charges
$_ = <charge_file>;
($login, $fund, $dept, $realname, $item, $units, $rate, $exp, $comment, $type, $perm) = split(/\|/);
$pfund = $fund;
$pdept = $dept;
$plogin = $login;
$pexp = $exp;
$pcomment = $comment;
$ptype = $type;
$pperm = $perm;

format =
@<<<<<<< @<<<<<<<<<<<<<<<<<<<<<<<< @<<<<<< @<<<<<<<<<<<<<< @>>>>>>>>>>>>>>>> @>>>>>>> @>>>>>>>> @<<<<<<<<<<<<<<<< @<<<<<<<<<< @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$prlogin   $prrealname               $asc    $item           $units            $rate    $t        $prtype            $prperm $warn
. 

# Read all the charges, total up all charges within the same funding
# source.
while( ! eof ) {

	# Set the point size, vspace, and print the dept name for
	# this table.
	printf("\n                                                          USAGE FOR: %s\n\n\n", $dept);

	# Print the table definition.
	printf("LOGIN    REAL-NAME                 EXP.    ITEM                  UNITS-USED COST/UNIT     TOTAL ACCOUNT TYPE      PERM NUMBER  WARNING\n");
	printf("-----------------------------------------------------------------------------------------------------------------------------------------------\n\n");

	# Keep reading and continue with this table until a new dept.
	while( $pdept eq $dept ) {

		# Convert user's expiration date from numeric format
		# to "88Jan01" style and print.
		$year = substr($exp, 0, 2);
		$mon = $m{substr($exp, 2, 2)};
		$day = substr($exp, 4, 2);
		$asc = $year.$mon.$day;

		# Prepare a warning field if the expiration date is
		# within one or two months.
		if( $exp <= $numdate ) 
			{$warn = "Account expired, deleted.";}
		elsif( ($exp > $numdate) && ($exp < $onemon) ) 
			{$warn = "Account expires within 30 days*****";} 
		elsif( ($exp >= $onemon) && ($exp <= $twomon) )
			{$warn = "Account expires within 60 days.";} 
		else {$warn = "	";}

		# Print the realname name in first field
		$prrealname = $realname;
		$prlogin = $login;
		$prtype = $type;
		$prperm = $perm;

		# Keep reading and totaling until a new login	
		while ($plogin eq $login ) {
			if ($fund eq "NON-UC") {
				$rate = $rate * $NONUC_MULT;
			}
			$t = $units * $rate;
			$units = sprintf("%.2f", $units);
			$rate =  sprintf("%.5f", $rate);
			$t =     sprintf("%.2f", $t);
			write();

			# zero things that only get printed on first line.
			$asc = " ";
			$warn = " ";
			$prlogin = " ";
			$prrealname = " ";
			$prtype = " ";
			$prperm = " ";

			$sum += $t;
			$_ = <charge_file>;
			($login, $fund, $dept, $realname, $item, $units, $rate, $exp, $comment, $type, $perm) = split(/\|/);
		}
		
		# Now we have the total for this user.  If below min
		# charge, set his sum to mincharge.  Print the sum.
		if( $sum < $MIN ) { $sum = $MIN;}
		$sum = sprintf("Total: %8.2f", $sum);
		printf("%95s\n\n", $sum);
		$sum = 0;
		$plogin = $login;
	}

	printf("");
	$pdept = $dept;
}
unlink $TEMP;
