# /usr/bin/perl --

#
# check: uses rusers to let you know when someone remotely logs in.
#
# Copyright (C) Matthw Green, 1922.
#               phone@coombs.anu.edu.au
#
# Usage - check [-hhostname] [-uusername] [-wN] [-b] [-d]
#    Where hostname, username are the addresses you want to check
#    for, N is the time interval you wish between checking, the
#    -b switch will turn beeping off, and -d will make it not show
#    the date for each sucessful lookup.
#

$beep		= 1;				# beep by default.
$show_date	= 1;				# show date by default..
$debug		= 0;				# value of debuging..

@progname = split (/\//, $0);
$progname = pop @progname;

foreach $i (0 .. $#ARGV)
{
	if	($ARGV[$i] =~ /^-u(\S*)/)
		{ $who = $1; }
	elsif	($ARGV[$i] =~ /^-h(\S*)/)
		{ $host = $1; }
	elsif	($ARGV[$i] =~ /^-w(\S*)/)
		{ $waittime = $1; }
	elsif	($ARGV[$i] =~ /^-b/)
		{ $beep = 0; }
	elsif	($ARGV[$i] =~ /^-d/)
		{ $show_date = 0; }
	else
		{ die "Usage: $progname [-hhostname] [-uusername] [-wN] [-b]\n"; }
}

$waittime			= 60 unless $waittime;
$who				= "kjs" unless $who;
$host				= "ozcrud.nsa.mil" unless $host;

($debug) && print "host - $host, who - $who, beep - $beep, waittime - $waittime..\n";

while (1)
{
	if (getppid() == 1)	# die if parent is init.
		{ exit(-1); }
	open (RUSERS, "rusers -l $host |") || die "rusers failed\n";
	@output = <RUSERS>;

	@got = grep (/^$who/, @output);
	if (@got)
	{
		if ($beep)
			{ print ""; }
		if ($show_date)
		{
			$date = `date`;
			chop $date;
		}
		foreach (@got)
		{
			($show_date) && print "$date - ";
			print "$_";
		}
	}
	
	sleep $waittime;
}

