#/usr/bin/perl -w
# Rev1.1 Joseph P. DeCello III
#        Michigan State University
#################################################################
# This script will generate an entry for .buddb for the host(s) #
# list from the commmand line.  Output is to STDOUT by default. #
#################################################################
# 1.0 - initial version
# 1.1 - added correct escape sequences

# This initializes the array of parameters with defaults.
#
@params = (
	'',                   # 0 Host
	'root',               # 1 User - run backup as
	'',                   # 2 ID - device name
	'Exabyte-2.3GB',      # 3 Media Server
	'',                   # 4 Path prefix
	'',                   # 5 Notes
	'',                   # 6 Mail To - This is in addition to "Bud Report".
	'1',                  # 7 History
	'0',                  # 8 Non-used paramter - set to "0"
	'dump',               # 9 Type
	# Levels - Priority | Group | Mail - needs to have "Mail To" value.
				'0',      '',     '0',	# 10-12 Level 0
				'0',      '',     '0', 	# 13-15 Level 0
				'0',      '',     '0',	# 16-18 Level 0
				'0',      '',     '0',	# 19-21 Level 0
				'0',      '',     '0',	# 22-24 Level 0
				'0',      '',     '0',	# 25-27 Level 0
				'0',      '',     '0',	# 28-30 Level 0
				'0',      '',     '0', 	# 31-33 Level 0
				'0',      '',     '0', 	# 34-36 Level 0
				'0',      '',     '0', 	# 37-39 Level 0
	''                    # 40 Filesystem
);

open(OUT,"| cat ");

if ($#ARGV == -1) { 
	print OUT "usage: buddb host1..hostn\n"; 
	exit 1; 
}

foreach $host (@ARGV) {

	open(DF,"rsh $host 'df | grep ^/' | ") || die "Unable to open $host\n";

	while( $filesys = <DF> ) {

		@params[0] = $host;
		@field = split(' ',$filesys);
		@fs = split('/',$field[0]);
		@params [2] = @fs[2];
		@params [4] = @field[5];
		@params [40] = @field[0];

		# This loop prints out the entry of parameters seperate by pipes.
		for ($i=0; $i<40; $i++) { 
			print OUT @params[$i], "|"; 
		}
		print OUT @params[40], "\n";

	} # end of while

} # end of foreach $host

close(DF); 
close(OUT);


