From: Tom Christiansen <tchrist@convex.COM>
Subject: Re: Recursive 'walk' into dir
Date: Wed, 7 Oct 1992 09:10:14 GMT
Organization: Convex Computer Corporation, Colorado Springs, CO
Lines: 94

From the keyboard of dat91uni@ludat.lth.se (Urban Nilsson):
:
:Yo !
:
:I'm a total newbie to perl (well i've tried it for a week or so) !
:and would like to get some help in constructing a program that
:takes away (deletes) all backupfiles at my account.
:
:It wouild be nice if it did a recursive walk into the sub directories ...
:
:Is this possible in perl ?!? if so please show me how !

Sure, here are two approaches.

The first is to use the find program to do your work for you:

    #!/usr/bin/perl
    #
    # Given the name of a from directory and a to directory, make a copy
    # of the from directory rooted in the to directory, but make all the
    # *files* in the copy symbolic links.

    sub usage { die "usage: $0 olddir newdir\n"; }
    &usage unless @ARGV == 2;
    for (($srcdir, $dstdir) = @ARGV) {
	-d && next;
	warn "$0: $_ is not a directory\n";
	&usage;
    } 

    chdir $srcdir || die "can't cd to $srcdir: $!";
    open(FIND, "find . -print |") || die "can't fork: $!";
    <FIND>;  # skip dot
    while (<FIND>) {
	chop;
	next unless ($dev, $ino, $mode) = lstat($_);
	$mode &= 07777;
	s!^./!!;
	if (-d _) {
	    mkdir("$dstdir/$_", $mode)
		|| die "couldn't mkdir $dstdir/$_: $!";
	} else {
	    symlink("$srcdir/$_","$dstdir/$_")
		|| die "couldn't symlink $srcdir/$_ to $dstdir/$_: $!";
	} 
	
    } 
    close FIND || die "find exited nonzero";

The second is to do the find yourself:

    #!/usr/bin/perl
    #
    # Given the name of a from directory and a to directory, make a copy
    # of the from directory rooted in the to directory, but make all the
    # *files* in the copy symbolic links.

    sub usage { die "usage: $0 olddir newdir\n"; }
    &usage unless @ARGV == 2;

    for (($srcdir, $dstdir) = @ARGV) {
	-d && next;
	warn "$0: $_ is not a directory\n";
	&usage;
    } 

    chdir $srcdir || die "can't cd to $srcdir: $!";

    require 'find.pl';

    &find('.');

    sub wanted {
	(($dev, $ino, $mode) = lstat($_)) || return 0;
	$mode &= 07777;
	return 1 if $name eq '.';
	$name =~ s!^\./!!;
	if (-d _) {
	    mkdir("$dstdir/$name", $mode)
		|| die "couldn't mkdir $dstdir/$name: $!";
	} else {
	    symlink("$srcdir/$name","$dstdir/$name")
		|| die "couldn't symlink $srcdir/$name to $dstdir/$name: $!";
	} 
	1;
    } 

--tom

-- 
    Tom Christiansen      tchrist@convex.com      convex!tchrist

    "The road to hell is paved with melting snowballs."
		--Larry Wall in  <1992Jul2.222039.26476@netlabs.com>

