>>>>> On 28 Jan 92 18:15:21 GMT, greiner@col.hp.com (Mike Greiner) said:
 
Mike> I wrote a variation on the password program from The Book, starting
Mike> on p282, that I'd like to change yet a bit more.  Rather than 
Mike> turning off the echo (system 'tty','-echo' -- which causes nothing
Mike> to show up when the user types) I want to provide some feedback 
Mike> as the passwords are entered.  Something like:
 
Mike> Enter the new password: ******
 
Mike> ****'s appear as the user types, one * for each character entered.
Mike> I played with getc a little, but it seemed to wait for a \n to
Mike> signal the end of user input.  I think I need something that can
Mike> actually trigger an action on *each keypress* of user input.  Ideas?
 
The solution is to call
 
        system('/bin/stty cbreak');
 
which will cause *every* keypress to be caught seperately (when using
getc).  Here's a little piece of code which does what you want:
(The command line editing you'll have to do for yourself, you should
use the constants defined in termios.ph)
 
----------------------------------------------------------------------
#!/bin/perl
 
require "sys/termios.ph";
system("/bin/stty cbreak -echo brkint");
 
$SIG{"INT"} = its_over;
 
print "Enter password: ";
select(STDOUT); $| = 1;
while() {
    $_ = $char = getc;
    last if (ord($char) == &VEOF ) ;
    last if ($char eq "\n");
    print "*";
    $password .= $char;
}
 
&its_over;
 
sub its_over { 
    system("/bin/stty sane echo"); 
    print "\nYou entered: $password\n";
    exit; }
----------------------------------------------------------------------
 
BUT!!!!! Remember that it's not a good idea to do it this way... If
you show a `*' for each letter, a person standing next to the user
typing can easily see how long the password is!!!!!!
 
/Kresten
krab@iesd.auc.dk (Kresten Krab Thorup)
