#!/usr/bin/perl
#
# langchk: see which "language" a particular page of Voynich is written in.
#
# 10 Jan 92, Jim Gillogly

$page = shift;

$text = "";

while (<>)
{
        $text .= $_ if /<$page/;
}

$text =~ s/{[^}]*}//g;          # Strip comments
$text =~ s/<[^>]*>//g;          # Strip line numbers
$text =~ s/\./ /g;              # Convert dot to space
$text =~ s/\n/ /g;              # Get rid of newlines
$text =~ s/ +/ /g;              # Collapse multiple spaces to single ones


study($text);                   # Maybe speed up next searches

$nwords = ($text =~ s/( \S)/$1/g);     # Count the words

print "Page $page\n";
exit if $nwords == 0;                  # Informational page or something
print "nwords = $nwords.\n";

$testa = ($text =~ s/(89) /$1/g);        # Count word-final 89
print "Test a) word-final 89 is $testa of $nwords\n";

$testb1 = ($text =~ s/(SOE)/$1/g);      # Count SOE
$testb2 = ($text =~ s/(SOR)/$1/g);      # Count SOR
$testb3 = ($text =~ s/(SOE *SOE )/$1/g); # Count SOE repeated
$testb4 = ($text =~ s/(SOR *SOR )/$1/g); # Count SOR repeated

print "Test b) SOE is $testb1 of $nwords.\n";
print "Test b) SOR is $testb2 of $nwords.\n";
print "Test b) SOE repeated: $testb3.\n";
print "Test b) SOR repeated: $testb4.\n";

$testc = ($text =~ s/( SA[MN] )/$1/g);     # Count SAN or SAM

print "Test c) SAM or SAN separately: $testc.\n";

$testd = ($text =~ s/( SOP)/$1/g);      # Count initial SOP

print "Test d) Initial SOP $testd.\n";

$teste = ($text =~ s/( Q)/$1/g);      # Count initial Q

print "Test e) Initial Q $teste.\n";

$score = ($testa / $nwords < .1) + (($testb1 + $testb2) / $nwords > .05) +
         ($testb3 + $testb4 > 0) + ($testc > .02) + ($testd > .02) +
         ($teste > .02);

print "Overall score for page $page: $score.\n\n";
