From: tye@spillman.uucp (E. Tye McQueen)
Subject: Re: Need some help with binary handling in perl
Date: Tue, 03 Nov 1992 07:06:15 GMT
Organization: Spillman Data Systems
Lines: 38

asherman@fmrco.com (Aaron Sherman) writes:
)The goal  is  to take  a  mask  and  increment the  number though  all
)permutations that  can be reached by setting  bits  in the number that
)are 0 in the mask.

Split the bits of the number into two groups:  Those where the mask bit
is 0 and those where the mask bit is 1.  You can do the split and rejoin
by using intermediate values in the format of "array of bits":

    $addr= "123.69.45.10";
    $amask= "254.127.251.255";  # Not many 0 bits for a short example
    $num= pack( "C4", split(/\./,$addr) );  # Store address as 4 bytes
    $mask= pack( "C4", split(/\./,$amask) );# Same for mask
    @numbits= split( //, unpack("B32",$num) );  # Bits of address
    @mskbits= split( //, unpack("B32",$mask) ); # Bits of mask
    @ones= grep( 1==$mskbits[$_], (0..@mskbits) );  # Mask 1-bit posi