#! /usr/bin/perl --
#
# mhpager - (C) Matthew Green, 1992.
#
# filter for mh mail reader "show".
#
# uses file "$HOME/.mhpager" as to which headers not to show.
#
# Environment:
#              MHMORE_FILE tells the program what file in the
#              mail path directory, defined in $HOME/.mh_profile
#              to look for.  Default is .mhpager.  -f option
#              overrides this.
#
#              PAGER use this pager.. -m option overrides this.
#
#              TMPDIR use this directory for temporary files.
#              Default is /tmp.
#

# Work out what to use!

$home = "$ENV{HOME}";
open (MHPROFILE, "<$home/.mh_profile") || die "$0: no $home/.mh_profile!";
while (<MHPROFILE>)
{
	if (/^Path: (.*)/i)
	{
		$mhpath = $1;
		if ($mhpath !~ /^\//)
			{ $mhpath = "$home/$mhpath"; }
		@trash = <MHPROFILE>;
	}
}

$mhfile = "$ENV{MHMORE_FILE}";
$mhpager = "$ENV{PAGER}";
if ($mhfile)
	{ $mhfile = "$mhpath/$mhfile"; }
else
	{ $mhfile = "$mhpath/.mhpager"; }
$mhpager = "/elec/h/gu/mrgreen/bin/sun4/less" unless $mhpager;

# Read the file of what to ignore!

if (! -e $mhfile)
	{ $nothing = 0; }
else
	{ $nothing = 1; }
if (open (MHFILE, "<$mhfile"))
{
	@dontshow = <MHFILE>;
	close MHFILE;
	foreach $i (0 .. $#dontshow)
	{
		chop $dontshow[$i];
	}
}

# Open tmp file.

if ($ENV{TMPDIR} eq '')
	{ $tmpfile = "/tmp/mhpager.$$"; }
else
	{ $tmpfile = "$ENV{TMPDIR}/mhpager.$$"; }
open (TMP, ">$tmpfile") || die "$0: can't open $tmpfile\n";

# read file in..

$headers = $nothing;
$showing = 1;
while (<>)
{
	$line = $_;
	if ($headers) 
	{
		if (/^$/)
			{ $headers = 0; }
		$show = 1;
		foreach(@dontshow)
		{
			if ($line =~ /^$_:/i)
			{
				$show = 0;
				$showing = 0;
			}
		}
		if ($show)
		{
			if (($line =~ /^\S/) || $showing)
			{
				print TMP "$line";
				$showing = 1;
			}
		}
	}
	else
		{ print TMP "$line"; }
}
close TMP;

# do final output..

system "$mhpager", "$tmpfile";
unlink "$tmpfile";
exit (0);
