From: mellan@syst06.acri.fr (Alain Mellan) 27 Oct 92 10:26:18 GMT
Subject: Re: scanning /etc/netgroup?
Organization: A.C.R.I., Lyon, France

I have such a beast. My start point was that gsh/gcp work fine, but
you have to maintain a separate database just for them. So I decided
to write a netsh/netcp relying on the NIS-distributed netgroup, wich
is (should be ? :-) the most up-to-date database.

Here is a shar containing the source for netsh, netcp and the
expand_netgroup.pl library file. Most of the wrapping code in
netsh/netcp is borrowed from gsh/gcp. 

Feel free to fix the bugs ;-) and improve those small scripts !!
(keep me posted on the improvements).

#! /bin/sh
# This is a shell archive.  Remove anything before this line, then feed it
# into a shell via "sh file" or similar.  To overwrite existing files,
# type "sh file -c".
# The tool that generated this appeared in the comp.sources.unix newsgroup;
# send mail to comp-sources-unix@uunet.uu.net if you want that tool.
# Contents:  netcp netsh expand_netgroup.pl
# Wrapped by mellan@syst06 on Tue Oct 27 11:19:07 1992
PATH=/bin:/usr/bin:/usr/ucb ; export PATH
echo If this archive is complete, you will see the following message:
echo '          "shar: End of archive."'
if test -f 'netcp' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'netcp'\"
else
  echo shar: Extracting \"'netcp'\" \(1789 characters\)
  sed "s/^X//" >'netcp' <<'END_OF_FILE'
X#!/usr/local/bin/perl --      # -*- Perl -*-
X
X# $Header: gcp,v 4.0 91/03/20 01:10:05 lwall Locked $
X
X# Here is a script to do global rcps.  See man page.
X
X$#ARGV >= 1 || die "Not enough arguments.\n";
X
Xif ($ARGV[0] eq '-r') {
X    $rcp = 'rcp -r';
X    shift;
X} else {
X    $rcp = 'rcp';
X}
X$args = $rcp;
X$dest = $ARGV[$#ARGV];
X
X$SIG{'QUIT'} = 'CLEANUP';
X$SIG{'INT'} = 'CONT';
X
Xwhile ($arg = shift) {
X    if ($arg =~ /^([-a-zA-Z0-9_+]+):/) {
X	if ($systype && $systype ne $1) {
X	    die "Can't mix system type specifers ($systype vs $1).\n";
X	}
X	$#ARGV < 0 || $arg !~ /:$/ || die "No source file specified.\n";
X	$systype = $1;
X	$args .= " $arg";
X    } else {
X	if ($#ARGV >= 0) {
X	    if ($arg =~ /^[\/~]/) {
X		$arg =~ /^(.*)\// && ($dir = $1);
X	    } else {
X		if (!$pwd) {
X		    chop($pwd = `pwd`);
X		}
X		$dir = $pwd;
X	    }
X	}
X	if ($olddir && $dir ne $olddir && $dest =~ /:$/) {
X	    $args .= " $dest$olddir; $rcp";
X	}
X	$olddir = $dir;
X	$args .= " $arg";
X    }
X}
X
Xdie "No system type specified.\n" unless $systype;
X
X$args =~ s/:$/:$olddir/;
X
Xchop($thishost = `hostname`);
X
Xdo '/system1/bin/expand_netgroup.pl';
X
X$remainder = '';
X
Xforeach $host (&expand_netgroup($systype)) {
X    next line if $host eq $thishost; # should handle aliases too
X    ($cmd = $args) =~ s/[ \t]$systype:/ $host:/g;
X    print "$cmd\n";
X    $result = `$cmd 2>&1`;
X    $remainder .= "$host+" if
X    $result =~ /Connection timed out|Permission denied/;
X    print $result;
X}
X
Xif ($remainder) {
X    chop($remainder);
X    open(grem,">.grem") || (printf stderr "Can't create .grem: $!\n");
X    print grem 'rem=', $remainder, "\n";
X    close(grem);
X    print 'rem=', $remainder, "\n";
X}
X
Xsub CLEANUP {
X    exit;
X}
X
Xsub CONT {
X    print "Continuing...\n";	# Just ignore the signal that kills rcp
X    $remainder .= "$host+";
X}
X
X
END_OF_FILE
  if test 1789 -ne `wc -c <'netcp'`; then
    echo shar: \"'netcp'\" unpacked with wrong size!
  fi
  chmod +x 'netcp'
  # end of 'netcp'
fi
if test -f 'netsh' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'netsh'\"
else
  echo shar: Extracting \"'netsh'\" \(1882 characters\)
  sed "s/^X//" >'netsh' <<'END_OF_FILE'
X#!/usr/local/bin/perl --        # -*- Perl -*-
X
X# Do rsh globally, based on the /etc/netgroup database
X
X$SIG{'QUIT'} = 'quit';			# install signal handler for SIGQUIT
X
Xsub getswitches {
X    while ($ARGV[0] =~ /^-/) {		# parse switches
X	$ARGV[0] =~ /^-h/ && ($showhost++,$silent++,shift(@ARGV),next);
X	$ARGV[0] =~ /^-s/ && ($silent++,shift(@ARGV),next);
X	$ARGV[0] =~ /^-d/ && ($dodist++,shift(@ARGV),next);
X	$ARGV[0] =~ /^-n/ && ($n=' -n',shift(@ARGV),next);
X	$ARGV[0] =~ /^-l/ && ($l=' -l ' . $ARGV[1],shift(@ARGV),shift(@ARGV),
X				next);
X	last;
X    }
X}
X
X
Xdo '/system1/bin/expand_netgroup.pl';
X
X
Xdo getswitches();		# get any switches before class
X$systype = shift;		# get name representing set of hosts
Xdo getswitches();		# same switches allowed after class
X
X$cmd = join(' ',@ARGV);		# remaining args constitute the command
X$cmd =~ s/'/'"'"'/g;			# quote any embedded single quotes
X
X$remainder = '';
X
X
Xforeach $host (&expand_netgroup($systype)) {
X    $showhost = "$host:\t";
X    print "rsh $host$l$n '$cmd'\n" unless $silent;
X    $SIG{'INT'} = 'DEFAULT';
X    if (open(PIPE,"rsh $host$l$n '$cmd'$dist 2>&1|")) {	# start an rsh
X        $SIG{'INT'} = 'cont';
X	for ($iter=0; <PIPE>; $iter++) {
X	    unless ($iter) {
X		$remainder .= "$host+"
X		    if /Connection timed out|Permission denied/;
X	    }
X	    print $showhost,$_;
X	}
X	close(PIPE);
X    } else {
X	print "(Can't execute rsh: $!)\n";
X	$SIG{'INT'} = 'cont';
X    }
X}
X
Xunlink "/tmp/gsh$$" if $dodist;
X
Xif ($remainder) {
X    chop($remainder);
X    open(grem,">.grem") || (printf stderr "Can't make a .grem file: $!\n");
X    print grem 'rem=', $remainder, "\n";
X    close(grem);
X    print 'rem=', $remainder, "\n";
X}
X
X# here are a couple of subroutines that serve as signal handlers
X
Xsub cont {
X    print "\rContinuing...\n";
X    $remainder .= "$host+";
X}
X
Xsub quit {
X    $| = 1;
X    print "\r";
X    $SIG{'INT'} = '';
X    kill 2, $$;
X}
END_OF_FILE
  if test 1882 -ne `wc -c <'netsh'`; then
    echo shar: \"'netsh'\" unpacked with wrong size!
  fi
  chmod +x 'netsh'
  # end of 'netsh'
fi
if test -f 'expand_netgroup.pl' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'expand_netgroup.pl'\"
else
  echo shar: Extracting \"'expand_netgroup.pl'\" \(1314 characters\)
  sed "s/^X//" >'expand_netgroup.pl' <<'END_OF_FILE'
Xsub expand_netgroup {
X    local($args) = shift;
X    local(@gl,$groupname,@groups,@hosts,$host);
X
X    $args =~ s/\+/:+/g;
X    $args =~ s/\-/:-/g;
X    $args = '+' . $args;
X    
X
X    open(netgroup, "ypcat -k netgroup |");
X
X# first, built the group list, wich is an associative array indexed
X# on the groupname.
X
X    while(<netgroup>) {
X	if (! /\(/) {
X	    ($groupname, @groups) = split;
X	    $gl{$groupname} = ':+' . join(':+', @groups);
X	} else {
X	    ($groupname, @hosts) = split;
X	    for ($i = 0; $i <= $#hosts; $i++) {
X		$hosts[$i] =~ s/\((.*),.*/\1/;
X		chop($hosts[$i]);
X		$gl{$hosts[$i]} = $hosts[$i];
X	    }
X	    $gl{$groupname} = join(':', @hosts);
X	}
X    }
X
X# now, expand $args recursively
X
X    sub expand {
X	local($args) = shift ;
X	local(@list) = ();
X	
X	foreach $group (split(':', $args)) {
X	    if ($group  =~ /^\+(\w+)/) {
X		$name = $1;
X		foreach $host (split(':', $gl{$name})) {
X		    if ($host =~ /^[\+|-].*/) {
X			push(@list, &expand($host));
X		    } else {
X			push(@list, $host);
X		    }
X		}
X	    } elsif ($group =~ /^-(\w+)/) {
X		$name = $1;
X		foreach $host (split(':', $gl{$name})) {
X		    if ($host =~ /^[\+|-].*/) {
X			push(@list, &expand($host));
X		    } else {
X			@newlist = grep(!/$host/, @list);
X			@list = @newlist;
X		    }
X		}
X	    }
X	}
X	return @list;
X    }
X
X    return (&expand($args));
X}
END_OF_FILE
  if test 1314 -ne `wc -c <'expand_netgroup.pl'`; then
    echo shar: \"'expand_netgroup.pl'\" unpacked with wrong size!
  fi
  # end of 'expand_netgroup.pl'
fi
echo shar: End of archive.
exit 0
--
Alain Mellan                          
Advanced Computer Research Institute 
1 Bvd Marius Vivier Merle             voice:  (+33) 72 35 84 92         
69443 LYON CEDEX 03 - FRANCE          email:    amellan@acri.fr

