From: turbo@cse.uta.edu (Chris Turbeville)
Subject: Re: HANDLING DISK QUOTAS 
Date: Wed, 10 Feb 1993 17:33:38 GMT
Organization: Comp Science Engineering at the University of Texas at Arlington

>This is a script which we use to help maintain quotas.  It is rather
>baroque since it doesn't attempt to grok the quota files directly, but
>rather relies on the dubious "features" of "edquota" and "quota -v".
>The advantage of this is that you don't have to know how quotas are
>actually implemented, just how to interface with "edquota" and "quota
>-v".  The disadvantage is that it is slower to do it this way, but it is
>faster (for the human) than simply using "edquota" and can be used
>non-interactively.
>
>There are a couple of embedded PATH definitions (search for PATH) which
>you will have to edit appropriately.
>
>It allows many user's quotas to be set `en masse' interactively or in
>"batch mode".
>
>It has a "wrapped" man page.
>
>Enjoy.
If you don't mind sneaking a peek at your /usr/include/sys/quota.h and
turning that structure into an unpack (which you might since you said you
were new but I thought I'd let you decide) you can do them wholesale.
I'd also apreciate if the net would let me know how this thing is going
to blow up in my face someday.
So for my uVAX I go to /usr/include/sys/quota.h (notice the package says
/usr/include/ufs/quota.h this is for suns and squents look at quota(2)
for the location) and get 
...
struct	dqblk {
	u_long	
	u_long	
	u_long	
	u_short	
	u_short	
	u_short	
	u_char	
	u_char	
};
...
So for my machine I use LLLSSSCC as $quota_rec_fmt easy huh:).  BTW in
these tables you are dealing with 512byte blocks so use 2x what you
want the 1k blk quota to be.  Also there is a hack at the end of
set_quota which to implement the new information does a quotaon quotaoff
anybody got any better ideas?
Thanks and hope this helps
-Chris

package quota;
##############################################################################
#                                                                            #
# Quota Package                                                              #
#                                                                            #
#     This package allows perl (albiet chunkyly) to modify a set of melborne #
# quotas for a system.  It bypasses all system calls by accessing the quotas #
# file in the root of the partition directly.                                #
#     Functions:                                                             #
#        @quotas = &get_quota($quota_file,$quota_rec_fmt)                    #
#            returns an array (indexed by uid) of the current                #
#              blkhard:blksoft:ihard:isoft                                   #
#              quota in 512 byte blocks.                                     #
#                                                                            #
#        &set_quota($quota_file,$quota_rec_fmt,@new_quotas)                  #
#            sets the system quotas to @new_quotas for the entire            #
#            partition.                                                      #
#                                                                            #
#  NOTE: format of $quota_rec_fmt can be found in /usr/include/ufs/quota.h   #
##############################################################################
#
# File		= $RCSfile: quota.pl,v $
# Revision	= $Revision: 1.2 $
# State		= $State: Exp $
# Author	= $Author: turbo $
# Date		= $Date: 1992/11/06 00:16:59 $
# Source	= $Source: /home/staff/turbo/adduser/RCS/quota.pl,v $
#
# ***Change History***
# $Log: quota.pl,v $
# Revision 1.2  1992/11/06  00:16:59  turbo
# All packages must return one.  Ooops!:)
#
# Revision 1.1  1992/11/06  00:13:37  turbo
# Initial revision
#
#
#
# Get quota reads in the quota array indexed by uid
#
#
sub get_quota
{
local($quota_file,$quota_rec_fmt) = @_;

local(@quota,$user,$line,$bhard,$bsoft,$curb,$ihard,$isoft,$curi,$bwarn,$iwarn);

open(QUOTAS,$quota_file) || die "Can't open quotas file $quota_file!\n";
$user = 0;
$size = 0;
for($i=0;$i<=length($quota_rec_fmt);$i++) {
	$_ = substr($quota_rec_fmt,$i,1);
	if (/L/) {
		$size = $size + 4;
	} elsif (/l/) {
		$size = $size + 4;
	} elsif (/S/) {
		$size = $size + 2;
	} elsif (/s/) {
		$size = $size + 2;
	} elsif (/C/) {
		$size = $size + 1;
	} elsif (/c/) {
		$size = $size + 1;
	}
}
while (read(QUOTAS,$_,$size)) {
	($bhard,
	$bsoft,
	$curb,
	$ihard,
	$isoft,
	$curi,
	$bwarn,
	$iwarn) = unpack($quota_rec_fmt,$_);
	$quota[$user++] = join(':',($bhard,$bsoft,$ihard,$isoft));
	}
close QUOTAS;
@quota;
}



#
#
# Set quota sets the quota based on the new array indexed by uid
#
#
sub set_quota
{
local($quota_file,$quota_rec_fmt,@newquota) = @_;

local($uid,$line,$bhard,$bsoft,$curb,$ihard,$isoft,$curi,$bwarn,$iwarn);

open(QUOTAS,"+<$quota_file") || die "Can't open quotas file $quota_file!\n";
$user = 0;
$size = 0;
for($i=0;$i<=length($quota_rec_fmt);$i++) {
	$_ = substr($quota_rec_fmt,$i,1);
	if (/L/) {
		$size = $size + 4;
	} elsif (/l/) {
		$size = $size + 4;
	} elsif (/S/) {
		$size = $size + 2;
	} elsif (/s/) {
		$size = $size + 2;
	} elsif (/C/) {
		$size = $size + 1;
	} elsif (/c/) {
		$size = $size + 1;
	}
}
for($uid=0;$uid<=$#newquota;$uid++)
	{
	seek(QUOTAS,$size*$uid,0);
	read(QUOTAS,$line,$size);
	($bhard,
	$bsoft,
	$curb,
	$ihard,
	$isoft,
	$curi,
	$bwarn,
	$iwarn) = unpack($quota_rec_fmt,$line);
	seek(QUOTAS,$size*$uid,0);
	($bhard,$bsoft,$ihard,$isoft) = split(':',$newquota[$uid]);
	print QUOTAS
	 pack($quota_rec_fmt,$bhard,$bsoft,$curb,$ihard,$isoft,$curi,$bwarn,$iwarn);
	}
close QUOTAS;
system("/usr/etc/quotaoff -a");
system("/usr/etc/quotaon -a");
}

1;

