From: sherman@unx.sas.com (Chris Sherman)
Subject: Re: how does one tar to stdout? and related?
Date: Sun, 11 Oct 1992 08:47:00 GMT
Organization: SAS Institute Inc.
Lines: 170

In <1992Oct8.184423.27220@fnbc.com> jja@fnbc.com (Joseph Alotta) writes:

>i have a problem getting tar to write to stdout.  i can get it to read  
>from stdin, but not the other way around.  i have these large files on 
>tape and i want to read and subset them before i write them on disk  
>because they are really big.  i'd like to do something like:

>tar -xvf /dev/rst0  mybigfile | grep "1000" | filter.pl

>but tar always writes to disk directly.  how can i fake it out?

Don't use tar!  Use something that acts like tar...

A had this problem a while back, and wrote the following which uses a
couple of lines from a program called 'tarfix' by Diomidis Spinellis for
reading the tar header information.  It is probably a trivial task to
modify it for your needs.

---------------------------------------------------------------------------

#!/usr/local/bin/perl 

# This script takes a tar file and extracts one file from it
# and writes that file to STDOUT, without using temporary files.

# Input can come in 3 forms:
#
# star <tar file> <filename>
#   
#      where <tar file> is the name of the tar file and <filename> is 
#      the name of the file you want to extract.

# star <tar file>
# <filename>
#
#      where <filename> is read in from STDIN

# star 
# <tar file>
# <filename>
#
#      where both <tar file> and <filename> are read in from STDIN


&getArgs;
&checkArgs;

open(INFILE,$arg1) || die ("Can't open $arg1!\n");
&copytar;

exit(0);

sub getArgs
{

  # no arguments on the command line, read args from STDIN
  if ($#ARGV == -1)
  {
    $arg1 = <STDIN> || die ("Couldn't read tar archive name from STDIN\n");
    $arg2 = <STDIN> || die ("Couldn't read search pattern from STDIN\n");
  }
  # one argument on the command line, read other arg from STDIN
  elsif ($#ARGV == 0)
  {
    $arg1 = $ARGV[0];
    $arg2 = <STDIN> || die("Couldn't read